/*


*/

import java.util.concurrent.ForkJoinPool;
import java.util.concurrent.RecursiveTask;
import java.util.Random;

/**
   This class represents a task to submit to the fork/join pool.
   If the task is "small", it should be solved sequentially.
   If the task is "large" it should be divided into subtasks
   that are then submitted to the fork/poin pool.
*/
@SuppressWarnings("serial")
class ZeroRun extends RecursiveTask<Integer>
{
   public static int SEQUENTIAL_CUTOFF = 100; // default value

   final int lo;
   final int hi;
   final int[] arr;

   ZeroRun(int[] arr, int lo, int hi)
   {
      this.arr = arr;
      this.lo = lo;
      this.hi = hi;
   }

   @Override
   public Integer compute()
   {


   }
}



/**
   This is the main() class. It creates an array of random numbers
   and then finds the length of the longest run of zeros both
   sequentially and using Fork/Join.
*/
public class Hw2
{
 //public static final int PROBLEM_SIZE =   1_000_003; // for zero filled arrays
   public static final int PROBLEM_SIZE = 700_000_003;

   public static int numbers[] = new int[PROBLEM_SIZE];

   public static void main(String[] args)
   {
      // Initialize the array of data.
      Random generator = new Random();
      int bound = 2 + generator.nextInt(10);
      System.out.printf("Array of %d random numbers between 0 and %d.\n", PROBLEM_SIZE, bound);
      for (int i = 0; i < numbers.length; i++)
      {
       //numbers[i] = 0; // Fill the array with all zeros.
         numbers[i] = generator.nextInt(bound);
      }

      long startTime;
      long stopTime;

      // Solve Sequentially.
      startTime = System.currentTimeMillis();
        int count = 0;



      stopTime = System.currentTimeMillis();
      System.out.println("Sequential:");
      System.out.println("  Sequential result: " + count);
      System.out.println("  Sequential solution time: " + (stopTime - startTime) + " ms");


      // Solve using Fork/Join.
      ZeroRun.SEQUENTIAL_CUTOFF = 1_000; // BE SURE TO EXPERIMENT WITH THIS!

      // Create the initial task item.
      ZeroRun t = new ZeroRun(numbers, 0, numbers.length);
      startTime = System.currentTimeMillis();
        // Put item t into the fork/join work queue.
        int result =  ForkJoinPool.commonPool().invoke(t);
      stopTime = System.currentTimeMillis();
      System.out.println("Parallel:");
      System.out.println("  SEQUENTIAL_CUTOFF: " + ZeroRun.SEQUENTIAL_CUTOFF);
      System.out.println("  Fork-Join result: " + result);
      System.out.println("  Fork-Join solution time: " + (stopTime - startTime) + " ms");
      System.out.println("ForkJoinPool: " + ForkJoinPool.commonPool().toString());
   }
}
